/*			-==========================-
			|		  TicTacToe 	   |
			-==========================-

main.c

Author : Minishlink
Created : May 2009
Latest modified : 27/05/09 (Day/Month/Year)

This is crappy to group all the functions here, but well, it's a small game...

Twitter : http://twitter.com/Minishlink
Website : http://minishlink.dev-fr.org and http://louislagrange.free.fr
MLlib Website : http://louislagrange.free.fr/MLlib 							*/

#include <MLlib.h>

#include "common.h"

static MODPlay mod;

int main(int argc, char **argv) 
{
	ML_Init();
	ML_SplashScreen();
	
	init();
	compo();
	retro();
	menu();
	    	
	return 0;
}

void menu()
{
	bool exit = 0;
	
	if(!ML_IsPlayingMOD()) ML_PlayMODFromBuffer(&mod, music_mod);
	
	while(1)
	{
		if(Wiimote[0].Newpress.Home) { exit = true; } 
		else if(Wiimote[0].Held.A && Wiimote[0].Held.B) jeu();
		
		ML_SetSpriteScale(FONT, 5, 5);
		ML_SimpleText(FONT, 160, 50, "TicTacToe");
		ML_SetSpriteScale(FONT, 2, 2);
		ML_SimpleText(FONT, 300, 90, "by Minishlink");
		
		ML_SetSpriteScale(FONT, 2.5, 2.5);
		if(Wiimote[0].Held.A) ML_SimpleText(FONT, 105, 190, "Press /A\\ + B to play !");	
		else if(Wiimote[0].Held.B) ML_SimpleText(FONT, 105, 190, "Press A + /B\\ to play !");	
		else ML_SimpleText(FONT, 125, 190, "Press A + B to play !");	
		
		ML_SimpleText(FONT, 190, 320, "Instructions :");
		
		ML_SetSpriteScale(FONT, 1.5, 1.5);
		ML_Text(FONT, 20, 360,  "- Point the Wiimote to the screen and press A.\n\n- Press B to reset the grid, scores will be saved.\n\n- Press Home if you want to reset scores or quit.\n\n- You can play with 1 or 2 Wiimotes.");
 		
		if(exit)
			if(ML_FadeOut()) ML_Exit();
		
		ML_Refresh();
	}	
}

void jeu()
{
	bool tour = 0, newGame = 1;
	int i, j;
	
	int damier[3][3] = {{0}};
	
	int cursorX, cursorY;
	u8 won = 0, times = 0, scorePlayerOne = 0, scorePlayerTwo = 0, wiimote = 0;
	
	while(1)
	{
		if(Wiimote[0].Released.Home) { menu(); } 
		else if(Wiimote[0].Newpress.B) newGame = 1;
		
		cursorX = sprite[CURSOR1+tour].x+sprite[CURSOR1+tour].width/2;
		cursorY = sprite[CURSOR1+tour].y+sprite[CURSOR1+tour].height/2;
		
		ML_DrawSprite(FOND);
		ML_SetSpriteScale(FONT, 5, 5);
		ML_SimpleText(FONT, 160, 50, "TicTacToe");
		
		ML_SetSpriteScale(FONT, 2, 2);
		ML_Text(FONT, 250, 100, "Player : %d", tour+1);		
		ML_Text(FONT, 260, 420, "Times : %d", times);
		
		ML_SetSpriteScale(FONT, 1.5, 1.5);
		ML_SimpleText(FONT, 50, 180, "Player 1 :");
		ML_SimpleText(FONT, 480, 180, "Player 2 :");
		
		ML_SetSpriteScale(FONT, 8, 16);
		ML_Text(FONT, 85, 270, "%d", scorePlayerOne);
		ML_Text(FONT, 530, 270, "%d", scorePlayerTwo);
		
		// Draw 1st line
		if(damier[0][0] == CROIX || damier[0][0] == ROND)
			ML_DrawSpriteXY(damier[0][0], (sprite[FOND].x+SIZE_BORDER), (sprite[FOND].y+SIZE_BORDER));
		
		if(damier[1][0] == CROIX || damier[1][0] == ROND)
			ML_DrawSpriteXY(damier[1][0], (sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC)), (sprite[FOND].y+SIZE_BORDER));
		
		if(damier[2][0] == CROIX || damier[2][0] == ROND)
			ML_DrawSpriteXY(damier[2][0], (sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*2)), (sprite[FOND].y+SIZE_BORDER));
		
		// Draw 2nd line
		if(damier[0][1] == CROIX || damier[0][1] == ROND)
			ML_DrawSpriteXY(damier[0][1], (sprite[FOND].x+SIZE_BORDER), (sprite[FOND].y+(SIZE_BORDER*2+SIZE_BLOC)));
			
		if(damier[1][1] == CROIX || damier[1][1] == ROND)
			ML_DrawSpriteXY(damier[1][1], (sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC)), (sprite[FOND].y+(SIZE_BORDER*2+SIZE_BLOC)));
			
		if(damier[2][1] == CROIX || damier[2][1] == ROND)
			ML_DrawSpriteXY(damier[2][1], (sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*2)), (sprite[FOND].y+(SIZE_BORDER*2+SIZE_BLOC)));
			
		// Draw 3rd line
		if(damier[0][2] == CROIX || damier[0][2] == ROND)
			ML_DrawSpriteXY(damier[0][2], (sprite[FOND].x+SIZE_BORDER), (sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2)));
			
		if(damier[1][2] == CROIX || damier[1][2] == ROND)
			ML_DrawSpriteXY(damier[1][2], (sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC)), (sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2)));
			
		if(damier[2][2] == CROIX || damier[2][2] == ROND)
			ML_DrawSpriteXY(damier[2][2], (sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*2)), (sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2)));
		
		// "Collisions"
		if(Wiimote[wiimote].Newpress.A && !won)
		{	
			// 1st line		
			if (cursorX <= sprite[FOND].x+(SIZE_BORDER+SIZE_BLOC) && cursorX >= sprite[FOND].x+SIZE_BORDER &&
				cursorY <= sprite[FOND].y+(SIZE_BORDER+SIZE_BLOC) && cursorY >= sprite[FOND].y+SIZE_BORDER &&
				(!damier[0][0]))
			{
				damier[0][0] = damierType(tour);
				tour^=1;
				times++;
			}
				
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC*2) && cursorX >= sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC) &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER+SIZE_BLOC) && cursorY >= sprite[FOND].y+SIZE_BORDER &&
					 (!damier[1][0]))
			{
				damier[1][0] = damierType(tour);
				tour^=1;
				times++;
			}
			
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*3) && cursorX >= sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*2) &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER+SIZE_BLOC) && cursorY >= sprite[FOND].y+SIZE_BORDER &&
					 (!damier[2][0]))
			{
				damier[2][0] = damierType(tour);
				tour^=1;
				times++;
			}
			
			// 2nd line
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER+SIZE_BLOC) && cursorX >= sprite[FOND].x+SIZE_BORDER &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2) && cursorY >= sprite[FOND].y+(SIZE_BORDER*2+SIZE_BLOC) &&
					 (!damier[0][1]))
			{
				damier[0][1] = damierType(tour);
				tour^=1;
				times++;
			}
			
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC*2) && cursorX >= sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC) &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2) && cursorY >= sprite[FOND].y+(SIZE_BORDER*2+SIZE_BLOC) &&
					 (!damier[1][1]))
			{
				damier[1][1] = damierType(tour);
				tour^=1;
				times++;
			}
			
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*3) && cursorX >= sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*2) &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2) && cursorY >= sprite[FOND].y+(SIZE_BORDER*2+SIZE_BLOC) &&
					 (!damier[2][1]))
			{
				damier[2][1] = damierType(tour);
				tour^=1;
				times++;
			}
			
			// 3rd line
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER+SIZE_BLOC) && cursorX >= sprite[FOND].x+SIZE_BORDER &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*3) && cursorY >= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2) &&
					 (!damier[0][2]))
			{
				damier[0][2] = damierType(tour);
				tour^=1;
				times++;
			}
			
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC*2) && cursorX >= sprite[FOND].x+(SIZE_BORDER*2+SIZE_BLOC) &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*3) && cursorY >= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2) &&
					 (!damier[1][2]))
			{
				damier[1][2] = damierType(tour);
				tour^=1;
				times++;
			}
			
			else if (cursorX <= sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*3) && cursorX >= sprite[FOND].x+(SIZE_BORDER*3+SIZE_BLOC*2) &&
					 cursorY <= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*3) && cursorY >= sprite[FOND].y+(SIZE_BORDER*3+SIZE_BLOC*2) &&
					 (!damier[2][2]))
			{
				damier[2][2] = damierType(tour);
				tour^=1;
				times++;
			}
		}
		
		// Detect if won
		if(times >= 5 && !won)
		{
			if ((damier[0][0] == damier[1][0] && damier[0][0] == damier[2][0] && damier[0][0] && damier[1][0] && damier[2][0]) || 
				(damier[0][1] == damier[1][1] && damier[0][1] == damier[2][1] && damier[0][1] && damier[1][1] && damier[2][1]) ||
				(damier[0][2] == damier[1][2] && damier[0][2] == damier[2][2] && damier[0][2] && damier[1][2] && damier[2][2]) || 
				(damier[0][0] == damier[0][1] && damier[0][0] == damier[0][2] && damier[0][0] && damier[0][1] && damier[0][2]) ||
				(damier[1][0] == damier[1][1] && damier[1][0] == damier[1][2] && damier[1][0] && damier[1][1] && damier[1][2]) || 
				(damier[2][0] == damier[2][1] && damier[2][0] == damier[2][2] && damier[2][0] && damier[2][1] && damier[2][2]) ||
				(damier[0][0] == damier[1][1] && damier[0][0] == damier[2][2] && damier[0][0] && damier[1][1] && damier[2][2]) || 
				(damier[2][0] == damier[1][1] && damier[2][0] == damier[0][2] && damier[2][0] && damier[1][1] && damier[0][2])  )
			won = 1;
		}
		
		if(won == 1) 
		{
			if(tour == 0) scorePlayerTwo++; // inverser les deux car ça change plus haut
			else scorePlayerOne++;
			
			won = 2;
		}	
		
		if(newGame)
		{
			for(i = 0; i < 3; i++)
				for(j = 0; j < 3; j++)
					damier[i][j] = 0;	
			
			if(scorePlayerOne < scorePlayerTwo) tour = 0;
			else if(scorePlayerOne > scorePlayerTwo) tour = 1;
			
			newGame = 0;	
			won = 0;
		}	
		
		if(tour == 0) { wiimote = 0; ML_SetSpriteAlpha(CURSOR2, 150); ML_SetSpriteAlpha(CURSOR1, 255); }
		else {
			if(Wiimote[1].Enabled) wiimote = 1; 
			else wiimote = 0;
			
			ML_SetSpriteAlpha(CURSOR1, 150);
			ML_SetSpriteAlpha(CURSOR2, 255);
		}
	
		if(Wiimote[1].Enabled) 
		{
			ML_Cursor(CURSOR1, 0);
			ML_Cursor(CURSOR2, 1);
		} else
			ML_Cursor(CURSOR1+tour, 0);
		
		//Easter egg which deserves to strictly nothing
		if((Wiimote[0].Held.One && ML_IsCollisionEx(CURSOR1, FOND)) || (Wiimote[1].Held.Two && ML_IsCollisionEx(CURSOR2, FOND)))
			sprite[FOND].visible = 0;
		else sprite[FOND].visible = 1;
		
		ML_Refresh();
	}		
}

int damierType(bool tour)
{
	if(tour == 0)
		return CROIX;
	else return ROND;
}

void retro()
{	
	int i = -200;
	
	while(i < 1200)
	{
		if(Wiimote[0].Released.Plus) i = 1200;
		
		if(i < 1198)
		{
			ML_DrawSprite(BG_RETRO);
		
			if(i >= 0)
			{
				if(i%40 < 20) 
				{
					ML_SetSpriteScale(FONT, 10, 20);
					ML_SimpleText(FONT, 70, 110, "WARNING");
				}
		
				ML_SetSpriteScale(FONT, 2, 2);
				if(i > 240) ML_Text(FONT, 40, 240, "This is a RETRO game:\nIt can give you some headaches\naccording to:\n   - its GRAPHICS\n   - its MUSIC!");	
				else ML_Text(FONT, 40, 480-i, "This is a RETRO game:\nIt can give you some headaches\naccording to:\n   - its GRAPHICS\n   - its MUSIC!");	
			
				if(i > 240) ML_SimpleText(FONT, 380, 300, "(LOL)");
			
				ML_SetSpriteScale(FONT, 1.5, 1.5);
				ML_SimpleText(FONT, 30, 430, "Press (+) to skip.");			
			}
		}
	
		i++;
		ML_Refresh();
	}
}

void compo()
{	
	ML_DrawSprite(BG_COMPO);
	ML_Refresh();
	
	sleep(5);
		
	ML_Refresh();
}

void init()
{	
	ML_InitMOD(&mod);
	
	ML_SetNumberOfPads(2, 0);
	
	ML_SetBackgroundColor(GX_COLOR_WHITE);
	ML_LoadSpriteFromBuffer(FONT, font_png, 0, 0);
	ML_InitTile(FONT, 8, 8);
	ML_SetSpriteScale(FONT, 2, 2);
	ML_LoadSpriteFromBuffer(BG_COMPO, bg_compo_png, 0, 0);
	ML_LoadSpriteFromBuffer(BG_RETRO, bg_retro_png, 0, 0);
	ML_LoadSpriteFromBuffer(FOND, fond_png, 640/2 - 128, 480/2 - 128);
	ML_LoadSpriteFromBuffer(CROIX, croix_png, 0, 0);
	ML_LoadSpriteFromBuffer(ROND, rond_png, 0, 0);
	ML_LoadSpriteFromBuffer(CURSOR1, cursor1_png, 0, 0);
	ML_LoadSpriteFromBuffer(CURSOR2, cursor2_png, 0, 0);
}

